#####EPUBCheck4.2の論理目次関連エラー修正パッチ#####
#####電書協ガイドEPUB用　解凍してあるEPUBフォルダ指定で.opfと論理目次ファイルを自動取得#####
#####階層構造の論理目次は対象外#####
use utf8;
#Encodeモジュールをインポート
use Encode qw/encode decode/;
use File::Basename;
use File::Find;
#EPUBファイルのパス指定
#my $epubFolderPath = $ARGV[0];
#$epubFolderPath = decode('UTF-8', $epubFolderPath);
my $epubFolderPath = "/tmp/epubfoldertemplate";
#OPF、論理目次のパス取得
my @opfFilePaths;
my @navigationFilePaths;
find(\&getEachFile, $epubFolderPath);
my $opffilePath = $opfFilePaths[0];
my $navfilePath = $navigationFilePaths[0];

#xhtmlファイル名をSPINEブロックでの表示順にリストとして取得
my @fileDisplayOrder = & getFileDisplayOrder ();

#論理目次ファイル内のリンク表示順を取得したリストを元に並べ替えて再出力
& exportSortedNavFile (@fileDisplayOrder);
exit;

#フォルダ内ファイルのパスを取得
sub getEachFile {
	my $file = $_;
	my $path = $File::Find::name;
	push(@opfFilePaths,$path) if ($path =~ /^.*?\.opf$/i);
	push(@navigationFilePaths,$path) if ($path =~ /^.*?\/navigation-documents\.xhtml$/i);
}

#ファイル表示順リスト取得サブルーチン
sub getFileDisplayOrder {
	#OPFファイル読み込み
	open(IN,"$opffilePath");
		#改行コードの統一処理
		my @eachLineTxts = <IN>;
		my $eachLineTxt = join("",@eachLineTxts);
		$eachLineTxt =~ s@\x0D\x0A@\x0D@g;
		$eachLineTxt =~ s@\x0A@\x0D@g;
		@eachLineTxts = split("\x0D",$eachLineTxt);
		my $joinedOpfTxt = join("\x0D\x0A",@eachLineTxts);
		$joinedOpfTxt = decode('UTF-8', $joinedOpfTxt);
	close (IN);
	
	#spineのidref内のidをリストで取得
	my @idrefs = $joinedOpfTxt =~ m/idref ?= ?\".*?\"/g;
	foreach(@idrefs){
		s@idref ?= ?\"(.*?)\"@$1@;
	}
	
	#manifestの各行をリスト取得
	my @manifestItem = $joinedOpfTxt =~ m/<item [^<>]+?>/g;
	
	#@idrefsと@manifestItemを付き合わせてxhtmlファイルを表示順にリストとして取得
	my @fileDisplayOrder;
	foreach (@idrefs){
		my $idString = $_;
		foreach (@manifestItem){
			if ($_ =~ /^<item .*?id ?= ?\"$idString\".*?>$/){
			s@^<item.*?href ?= ?\"(.+?)\".*?>$@$1@;
				my $matchedFilename = basename($_);
				push (@fileDisplayOrder, $matchedFilename);
			}
		}
	}
	return @fileDisplayOrder;
}

#論理目次再出力サブルーチン
sub exportSortedNavFile {
	#置換テキストの取得
	my @fileDisplayOrder = @_;
	
	#論理目次ファイル読み込み
	open(IN,"$navfilePath");
		#改行コードの統一処理
		my @eachLineTxts = <IN>;
		my $eachLineTxt = join("",@eachLineTxts);
		$eachLineTxt =~ s@\x0D\x0A@\x0D@g;
		$eachLineTxt =~ s@\x0A@\x0D@g;
		@eachLineTxts = split("\x0D",$eachLineTxt);
		my $joinedNavigationTxt = join("\x0D\x0A",@eachLineTxts);
		$joinedNavigationTxt = decode('UTF-8', $joinedNavigationTxt);
	close (IN);
	
	#論理目次ファイルの各パートを分割取得しておく
	$joinedNavigationTxt =~ m@^(.*?)(<nav[^<>]+?epub:type ?= ?"toc"[^<>]+?>.*?</nav>)(.*?)$@s;
	my $headerBlock = $1;
	my $navLinkBlockOriginal = $2;
	my $footerBlock = $3;
	
	#リンク表示部分の各行をリストで取得
	my @navLinkLine = $navLinkBlockOriginal =~ m/<li>.+?<\/li>/g;
	#リンクブロックのヘッダも取っておく（フッターは</ol></nav>で決め打ちなので省略）
	my $navLinkBlockHeader = $navLinkBlockOriginal;
	$navLinkBlockHeader =~ s@^(<nav .+?<ol>).+?$@$1@s;
	
	#目次表示リスト部分とOPFのxhtmlファイル表示の順番を付き合わせて並び替える処理
	my @sortedNavLinkLine;
	foreach my $xhtmlFileName(@fileDisplayOrder){
		foreach my $navLine(@navLinkLine){
			if ($navLine =~ /^<li>.+?$xhtmlFileName.+?<\/li>$/){
				push (@sortedNavLinkLine, $navLine);
			}
		}
	}
	my $joinedSortedNavLinkLine = join("\x0D\x0A",@sortedNavLinkLine);
	
	#リンクブロックのヘッダフッタくっつける
	my $navLinkBlockSorted = $navLinkBlockHeader . "\x0D\x0A" . $joinedSortedNavLinkLine . "\x0D\x0A</ol>\x0D\x0A</nav>";
	
	#論理目次全体を再結合
	my $mergedNavText = $headerBlock . $navLinkBlockSorted . $footerBlock;
	
	#ファイル出力
	$mergedNavText = encode('UTF-8', $mergedNavText);
	open(OUT,"> $navfilePath");
		print OUT $mergedNavText;
	close (OUT);
}