#! /usr/bin/perl
use utf8;
#Encodeモジュールをインポート
use Encode qw/encode decode/;
use File::Basename qw/basename dirname/;
use FindBin;
#外部ファイルインポートパスの設定、インポート
my $scriptDir = $FindBin::Bin;


my $imageRenameResizePath = $scriptDir . "/" . "imageresizerename.pl";
require $imageRenameResizePath;
my $pageFileOutputPath = $scriptDir . "/" . "pagefileoutput.pl";
require $pageFileOutputPath;
my $getImageWidthPath = $scriptDir . "/" . "getimagewidth.pl";
require $getImageWidthPath;
my $getImageHeightPath = $scriptDir . "/" . "getimageheight.pl";
require $getImageHeightPath;
my $opfCreatorBlockMargePath = $scriptDir . "/" . "opfcreatorblockmarge.pl";
require $opfCreatorBlockMargePath;
my $opfPublisherBlockMargePath = $scriptDir . "/" . "opfpublisherblockmarge.pl";
require $opfPublisherBlockMargePath;
my $opfManifestImageBlockMargePath = $scriptDir . "/" . "opfmanifestimageblockmarge.pl";
require $opfManifestImageBlockMargePath;
my $opfManifestXhtmlBlockMargePath = $scriptDir . "/" . "opfmanifestxhtmlblockmarge.pl";
require $opfManifestXhtmlBlockMargePath;
my $opfSpineBlockMargePath = $scriptDir . "/" . "opfspineblockmarge.pl";
require $opfSpineBlockMargePath;
my $opfFileOutputPath = $scriptDir . "/" . "opffileoutput.pl";
require $opfFileOutputPath;
my $navFileOutputPath = $scriptDir . "/" . "navfileoutput.pl";
require $navFileOutputPath;

#epubテンプレートフォルダをコピー
my $epubWorkFolderPath = "/tmp" . "/" . "epubfoldertemplate";
my $epubTemplateCopyCommand = "cp -R " . '"' . $scriptDir .  "/" . "epubfoldertemplate" . '"' . " " . $epubWorkFolderPath;
system $epubTemplateCopyCommand;

#各作業用仮出力フォルダの定義
our $workImageFolderPath = $epubWorkFolderPath . "/item/image";
our $workXhtmlFolderPath = $epubWorkFolderPath . "/item/xhtml";
our $workItemFolderPath = $epubWorkFolderPath . "/item";


#タイトル名の読み込み
my $myTitleName = $ARGV[0];
$myTitleName = decode('UTF-8', $myTitleName);
my $myTitleNameKana = $ARGV[1];
$myTitleNameKana = decode('UTF-8', $myTitleNameKana);
#制作者名の読み込み
our $myCreator1 = $ARGV[2];
$myCreator1 = decode('UTF-8', $myCreator1);
our $myCreator1role = $ARGV[3];
$myCreator1role = decode('UTF-8', $myCreator1role);
our $myCreator1kana = $ARGV[4];
$myCreator1kana = decode('UTF-8', $myCreator1kana);
our $myCreator2 = $ARGV[5];
$myCreator2 = decode('UTF-8', $myCreator2);
our $myCreator2role = $ARGV[6];
$myCreator2role = decode('UTF-8', $myCreator2role);
our $myCreator2kana = $ARGV[7];
$myCreator2kana = decode('UTF-8', $myCreator2kana);
our $myCreator3 = $ARGV[8];
$myCreator3 = decode('UTF-8', $myCreator3);
our $myCreator3role = $ARGV[9];
$myCreator3role = decode('UTF-8', $myCreator3role);
our $myCreator3kana = $ARGV[10];
$myCreator3kana = decode('UTF-8', $myCreator3kana);

#綴じ方向の読み込み
my $myPageDirection = $ARGV[11];
$myPageDirection = decode('UTF-8', $myPageDirection);

#見開き／単ページ指定の読み込み
our $myPageSpread = $ARGV[12];
$myPageSpread = decode('UTF-8', $myPageSpread);

#目次テーブル項目の読み込み
my $myNavImageMarge = $ARGV[13];
$myNavImageMarge = decode('UTF-8', $myNavImageMarge);
my $myNavTextMarge = $ARGV[14];
$myNavTextMarge = decode('UTF-8', $myNavTextMarge);
$myNavImageMarge =~ s@&apos;@\'@g;
$myNavImageMarge =~ s@&quot;@\"@g;
$myNavImageMarge =~ s@&lt;@<@g;
$myNavImageMarge =~ s@&gt;@>@g;
$myNavImageMarge =~ s@&amp;@&@g;

#元イメージフォルダパスの読み込み
my $OriginalImageFolderPath = $ARGV[15];
$OriginalImageFolderPath = decode('UTF-8', $OriginalImageFolderPath);
$OriginalImageFolderPath = '"' . $OriginalImageFolderPath . '"';

#結合済みイメージファイル名の読み込み
my $joinedOriginalImageName = $ARGV[16];
$joinedOriginalImageName = decode('UTF-8', $joinedOriginalImageName);
$joinedOriginalImageName =~ s@&apos;@\'@g;
$joinedOriginalImageName =~ s@&quot;@\"@g;
$joinedOriginalImageName =~ s@&lt;@<@g;
$joinedOriginalImageName =~ s@&gt;@>@g;
$joinedOriginalImageName =~ s@&amp;@&@g;

#出版者名の読み込み
my $myPublisher = $ARGV[17];
$myPublisher = decode('UTF-8', $myPublisher);
my $myPublisherKana = $ARGV[18];
$myPublisherKana = decode('UTF-8', $myPublisherKana);

#リサイズ画像サイズ（長辺）の読み込み
our $imageLongSideLength = $ARGV[19];
$imageLongSideLength = decode('UTF-8', $imageLongSideLength);

#リサイズ画質の読み込み
our $jpgImageQuality = $ARGV[20];
$jpgImageQuality = decode('UTF-8', $jpgImageQuality);
our $pngImageQuality = $ARGV[21];
$pngImageQuality = decode('UTF-8', $pngImageQuality);

#ImageMagickで画像のサイズ・画質等の変換をするかどうかの指定
our $myImageConvertExecution = $ARGV[22];
$myImageConvertExecution = decode('UTF-8', $myImageConvertExecution);

#目次テーブル項目分割、リスト化
$myNavImageMarge =~ s@\x{feff}@@ig;
$myNavTextMarge =~ s@\x{feff}@@ig;

our @myNavImageList = split(/〓■〓/,$myNavImageMarge);
our @myNavTextList = split(/〓■〓/,$myNavTextMarge);
our %navImageAndText;

#元イメージフォルダ内の画像ファイルを全て作業用イメージフォルダにコピー
my $jpgImageCopyCommand = "cp -r " . $OriginalImageFolderPath . "*.jpg" . " " . $workImageFolderPath . "|cp -r " . $OriginalImageFolderPath . "*.jpeg" . " " . $workImageFolderPath . "|cp -r " . $OriginalImageFolderPath . "*.png" . " " . $workImageFolderPath;
system $jpgImageCopyCommand;

#イメージのリネーム＆リサイズ、リネーム前後の画像名ハッシュ取得（目次出力時用）
our %imageBeforeAfter = &imageRenameResize($workImageFolderPath,$joinedOriginalImageName);

#イメージファイルのみをリストとして取得
my @allImageFiles;
foreach $file(sort keys %imageBeforeAfter){
	push @allImageFiles, $imageBeforeAfter{$file};
}

our %imagesAndXhtml;
#####################XHTMLファイルの出力処理#####################
foreach (@allImageFiles){
	our $imageWidth = &getImageWidth($workImageFolderPath . "/" . $_);
	our $imageHeight = &getImageHeight($workImageFolderPath . "/" . $_);
	#出力xhtmlファイル名の定義
	if ($_ eq "cover.jpg"){
		our $xhtmlFileName = "p-cover.xhtml";
	} elsif ($_ eq "cover.png"){
		our $xhtmlFileName = "p-cover.xhtml";
	} elsif ($_ =~ /\.jpg$/){
		our $xhtmlFileName = $_;
		$xhtmlFileName =~ s@i\-([0-9][0-9][0-9][0-9])\.jpg@p\-$1\.xhtml@;
	} elsif ($_ =~ /\.png$/){
		our $xhtmlFileName = $_;
		$xhtmlFileName =~ s@i\-([0-9][0-9][0-9][0-9])\.png@p\-$1\.xhtml@;
	}
	&xhtmlOutput($_,$xhtmlFileName,$workXhtmlFolderPath,$imageWidth,$imageHeight,$myTitleName);
	$imagesAndXhtml{$_} = $xhtmlFileName;
}

#####################OPFファイルの出力処理#####################
#制作者名ブロックの合成
if ($myCreator2kana eq 'null'){
	my $creatorBlock1 = &creatorBlockMarge($myCreator1,$myCreator1role,$myCreator1kana,1);
	our $totalCreatorBlock = $creatorBlock1;
} elsif ($myCreator3kana eq 'null'){
	my $creatorBlock1 = &creatorBlockMarge($myCreator1,$myCreator1role,$myCreator1kana,1);
	my $creatorBlock2 = &creatorBlockMarge($myCreator2,$myCreator2role,$myCreator2kana,2);
	our $totalCreatorBlock = $creatorBlock1 . "\x{000d}\x{000a}\x{000d}\x{000a}" . $creatorBlock2;
} else {
	my $creatorBlock1 = &creatorBlockMarge($myCreator1,$myCreator1role,$myCreator1kana,1);
	my $creatorBlock2 = &creatorBlockMarge($myCreator2,$myCreator2role,$myCreator2kana,2);
	my $creatorBlock3 = &creatorBlockMarge($myCreator3,$myCreator3role,$myCreator3kana,3);
	our $totalCreatorBlock = $creatorBlock1 . "\x{000d}\x{000a}\x{000d}\x{000a}" . $creatorBlock2 . "\x{000d}\x{000a}\x{000d}\x{000a}" . $creatorBlock3;
}

#出版社名ブロックの合成
if ($myPublisherKana eq 'null'){
	our $totalPublisherBlock = "";
} else {
	our $totalPublisherBlock = &publisherBlockMarge($myPublisher,$myPublisherKana);
}
#$totalPublisherBlock = encode('UTF-8', $totalPublisherBlock)

#マニフェスト画像ブロックの合成
my @manifestImageLines;
foreach (sort keys %imagesAndXhtml){
	my $eachLine = &manifestImageBlockMarge($_);
	push (@manifestImageLines,$eachLine);
}
my $totalManifestImageBlock = join ("\x{000d}\x{000a}",@manifestImageLines);

#マニフェストXHTMLブロックの合成
my @manifestXhtmlLines;
foreach (sort keys %imagesAndXhtml){
	my $eachLine = &manifestXhtmlBlockMarge($imagesAndXhtml{$_});
	push (@manifestXhtmlLines,$eachLine);
}
my $totalManifestXhtmlBlock = join ("\x{000d}\x{000a}",@manifestXhtmlLines);

#SPINEブロックの合成
my @spineLines;
my $pageSpreadNum = 0;
if ($myPageDirection eq "rtl"){
	$pageSpreadNum++;
}
foreach (sort keys %imagesAndXhtml){
	my $eachLine = &spineBlockMarge($imagesAndXhtml{$_},$pageSpreadNum);
	push (@spineLines,$eachLine);
	$pageSpreadNum++;
}
my $totalSpineBlock = join ("\x{000d}\x{000a}",@spineLines);
$totalSpineBlock = '<spine page-progression-direction="' . $myPageDirection . '">' . "\x{000d}\x{000a}\x{000d}\x{000a}" . $totalSpineBlock;

#UUIDの生成
my $uuidString = `uuidgen`;
$uuidString =~ s@\n@@;

#年月日時刻の生成
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;
my $dateTime = $year . "-" . sprintf("%02d",$mon) . "-" . sprintf("%02d",$mday) . "T" . sprintf("%02d",$hour) . ":" . sprintf("%02d",$min) . ":" . sprintf("%02d",$sec) . "Z";

#OPF出力処理
&opfFileOutput($myTitleName,$myTitleNameKana,$totalCreatorBlock,$totalPublisherBlock,$uuidString,$dateTime,$imageWidth,$imageHeight,$totalManifestImageBlock,$totalManifestXhtmlBlock,$totalSpineBlock,$workItemFolderPath,$myPageDirection);

#####################論理目次の出力処理#####################
&navOutput();

exit;
